<template>
  <div class="lab-form-container flex column">
    <div
      class="radio-questions m-b-20 flex column"
      v-if="radioQuestion.length !== 0"
    >
      <span class="title m-b-20">单选题</span>
      <QuestionItem
        v-for="(question, index) in radioQuestion"
        :key="index"
        :question="question"
        @change="changeHandler"
        v-show="question.step === step"
      ></QuestionItem>
    </div>
    <div
      class="multiple-selection-questions m-b-20 flex column"
      v-if="multipleQuestion.length !== 0"
    >
      <span class="title m-b-20">多选题</span>
      <QuestionItem
        v-for="(question, index) in multipleQuestion"
        :key="index"
        :question="question"
        @change="changeHandler"
        v-show="question.step === step"
      ></QuestionItem>
    </div>
    <div
      class="open-questions m-b-20 flex column"
      v-if="openQuestion.length !== 0"
    >
      <span class="title m-b-20">实验题</span>
      <QuestionItem
        v-for="(question, index) in openQuestion"
        :key="index"
        :question="question"
        @change="changeHandler"
        v-show="question.step === step"
      ></QuestionItem>
    </div>
    <div class="btn-group-container flex row content-center">
      <el-button
        class="theme-red-button small"
        @click="save"
        plain
        v-show="step === 2"
        >继续回答语音问题</el-button
      >
      <el-button
        class="theme-red-button small"
        @click="save"
        plain
        v-show="step === 1"
        >继续回答语音问题</el-button
      >
    </div>
  </div>
</template>

<script>
import isString from "lodash.isstring";
import isArray from "lodash.isarray";
import QuestionItem from "./question";
import { labs } from "@/api";
import { mapGetters } from "vuex";

export default {
  name: "labForm",
  props: {
    step: {
      type: Number,
      required: true
    }
  },
  components: {
    QuestionItem
  },
  data() {
    return {
      lab_id: -1,
      questions: [],
      questionTyes: ["Radio", "Multiple Selection", "Open Question"],
      choices: []
    };
  },
  computed: {
    ...mapGetters({ isLogin: "accounts/isLogin" }),
    radioQuestion() {
      return this.questions.filter(
        question => question.type === this.questionTyes[0]
      );
    },
    multipleQuestion() {
      return this.questions.filter(
        question => question.type === this.questionTyes[1]
      );
    },
    openQuestion() {
      return this.questions.filter(
        question => question.type === this.questionTyes[2]
      );
    }
  },
  methods: {
    async fetchQuestions() {
      let result = await labs.detail(1, {
        filters: {
          include: [
            {
              association: "questions",
              include: ["choices"]
            }
          ]
        }
      });
      this.lab_id = result.id;
      this.questions = result.questions;
      this.questionOverviews = this.questions.map(question => {
        return {
          id: question.id,
          seq: question.seq,
          type: question.type,
          choices: []
        };
      });
      this.questionIndex = 0;
    },
    changeHandler(item) {
      let idx = this.choices.findIndex(val => val.id === item.id);
      if (idx === -1) {
        this.choices.push(item);
      } else {
        this.choices[idx] = item;
      }
    },
    async save() {
      // let res;
      // let answer;
      let items = this.choices.map(choice => {
        let item = {
          question_id: choice.id
        };
        switch (true) {
          case isString(choice.data):
            item.text = choice.data;
            break;
          case isArray(choice.data):
            item.choices = choice.data;
            break;
        }
        return item;
      });
      this.$emit("save", items);
    }
  },
  async created() {
    await this.fetchQuestions();
  }
};
</script>

<style lang="scss" scoped>
@import "@/styles/theme.scss";
.lab-form-container {
  padding: 20px;
  .title {
    align-self: center;
    text-align: left;
    font-size: $font-title-size;
    color: $themeRed;
  }
  .question-item {
    margin-top: 20px;
    padding-left: 10px;
  }
  .btn-group-container {
    width: 100%;
    .el-button {
      width: 200px;
    }
  }
}
</style>
